
/**
 * Write a description of class GhostsStory here.
 *
 * @author (your name)
 * @version (a version number or a date)
 */

import ecs100.*;
import java.util.*;

public class GhostsStory
{

    public void many() {
        //Make list of ghosts
        ArrayList<Ghost> ghosts = new ArrayList<Ghost>();

        //Instantiate some ghosts
        

        //Make each of them move
        
        
        //Make them move in the same way, using a regular for-loop
        
    }

    public void manyUserGivenPostions() {
        //Make list of ghosts
        ArrayList<Ghost> ghosts = new ArrayList<Ghost>();

        //Get a list of positions
        ArrayList<Double> listPos = UI.askNumbers("Provide positions (x <enter> y <enter>)");
        
        //Check the list has a even number of entries
        if(listPos.size() % 2 != 0)
        {
            UI.println("Error: A position needs both an x and y value");
            return;
        }

        //Instantiate the Ghosts
        for(int i = 0; i<listPos.size(); i=i+2)
        {
            Ghost g = new Ghost(listPos.get(i), listPos.get(i+1), 25, 25);
            this.changeGhostTypeRandom(g);
            g.lookRight();
            ghosts.add(g);
        }

        //Move each ghost 10 positions
        for(Ghost g : ghosts)
        {
            for(int i = 0; i<10;i++)
            {
                g.move();

                //Check they are not colliding
                for(Ghost gOther: ghosts)
                {
                    if(!g.equals(gOther))
                    {
                        if(this.ghostCollide(g,gOther))
                        {
                            gOther.setScared(true);
                        }
                        else
                        {
                            gOther.setScared(false);
                        }
                    }
                }
            }
        }

        /*for(Ghost g : ghosts)
        {
        this.moveSquareAware(g, 8, ghosts);
        }*/
    }

    public void manyRandom() {
        //Create a list of Ghosts with random positions
        ArrayList<Ghost> ghosts = new ArrayList<Ghost>();
        for(int i = 0; i<50; i = i + 1) {
            //Get random (x,y)
            double x = Math.random()*300;
            double y = 50+ Math.random()*300;

            //Instantiate ghosts of random type and add them to ghosts
            Ghost g = new Ghost(x,y,25,25);
            this.changeGhostTypeRandom(g);
            ghosts.add(g);
        }

        //Move them using Squares
        //Update Ghosts to scare when they collide
        for(Ghost g : ghosts)
        {
            this.moveSquareAware(g, 8, ghosts);
        }
    }

    public void changeGhostTypeRandom(Ghost g) {
        double random = Math.random();

        //Change the ghosts type based on the random number
        if(random <0.25)
            g.setInky();

        if(random >=0.25 && random<0.5)
            g.setPinky();

        if(random >= 0.5 && random <0.75)
            g.setPokey();
    }

    public void many2D() {
        ArrayList<Ghost> ghosts = new ArrayList<Ghost>();

        //draw Ghosts in a square
        for(int x =100; x <=600; x = x + 100) 
        {
            for(int y = 100; y<=600; y = y + 50) 
            {
                Ghost g = new Ghost(x,y,25,25);
                this.changeGhostTypeRandom(g);
                ghosts.add(g);
            }
        }

        for(Ghost g: ghosts) 
        {
            moveSquareAware(g, 5, ghosts);
        }
    }

    public void moveSquare(Ghost g, int numSteps) {
        g.lookRight();
        this.moveSteps(g, numSteps);
        g.lookDown();
        this.moveSteps(g, numSteps);
        g.lookLeft();
        this.moveSteps(g, numSteps);
        g.lookUp();
        this.moveSteps(g, numSteps);
        g.lookStraight();
    }

    //Move in square redrawing all Ghosts in ghosts list in case they collide.
    public void moveSquareAware(Ghost g, int numSteps, ArrayList<Ghost> ghosts) {
        g.lookRight();
        this.moveStepsAware(g, numSteps, ghosts);
        g.lookDown();
        this.moveStepsAware(g, numSteps, ghosts);
        g.lookLeft();
        this.moveStepsAware(g, numSteps, ghosts);
        g.lookUp();
        this.moveStepsAware(g, numSteps, ghosts);
        g.lookStraight();
    }

    /**
     * Move the Ghost a number of steps forward
     * @param ghost the ghost that should move
     * @param count the number of "steps"
     */
    public void moveSteps(Ghost ghost, int count) {
        int i = 0;
        while(i<count) {
            ghost.move();
            i=i+1;
        }
    }

    /**
     * Move the Ghost a number of steps forward, redrawing all Ghosts in case they collide
     * @param ghost the ghost that should move
     * @param count the number of "steps"
     * @param ghosts list of ghosts of the environment
     */
    public void moveStepsAware(Ghost ghost, int count, ArrayList<Ghost> ghosts) {
        int i = 0;
        while(i<count) {
            ghost.move();
            //Draw all ghosts to avoid missing parts
            //Check they are not colliding
            for(Ghost gOther: ghosts)
            {
                if(!ghost.equals(gOther))
                {
                    if(ghostCollide(ghost,gOther))
                    {
                        gOther.setScared(true);
                    }
                    else
                    {
                        gOther.setScared(false);
                    }
                }
            }
            i=i+1;
        }
    }

    /**
     * Get the distance between two ghosts (using the middle of the ghosts)
     *    using Pythagoras (a*a + b*b = c*c <=> c = sqrt(a*a + b*b)) 
     * @param g1 Ghost #1
     * @param g2 Ghost #2
     */
    public double getDistance(Ghost g1, Ghost g2) {
        Double a2 = (g1.getMiddleX() - g2.getMiddleX()) * (g1.getMiddleX() - g2.getMiddleX());
        Double b2 = (g1.getMiddleY() - g2.getMiddleY()) * (g1.getMiddleY() - g2.getMiddleY());

        return Math.sqrt(a2 + b2);
    }

    /**
     * Two squares don't collide if
     *    one of them is to the left of the other, or
     *    one of them is below the other
     *    
     * Inspired by: https://www.geeksforgeeks.org/find-two-rectangles-overlap/
     */
    public boolean ghostCollide(Ghost g1, Ghost g2) {
        if(g1.getLeft() > g2.getRight() || g2.getLeft() > g1.getRight()) return false;
        if(g1.getTop() > g2.getBottom() || g2.getTop() > g1.getBottom()) return false;
        return true;
    }

    public void setupGUI() {
        UI.addButton("Many" , this::many);
        UI.addButton("Many (User)" , this::manyUserGivenPostions);
        UI.addButton("Many (Random)" , this::manyRandom);
        UI.addButton("Many (2D)" , this::many2D);
        UI.addButton("Clear", UI::clearGraphics);
    }

    public static void main(String[] args) {
        new GhostsStory().setupGUI();
    }
}
